/** test.js - javascript for the berzerk test page
 * 
 */

var maxReturnedLines = 20;

function onloadTest() {
	$("input[type='text']").change(function() {
		processCurrentFilter();
	});
	$("#logFiles").change(function() {
		processCurrentFilter();
	});
	$("#filters").change(function() {
		doFilterChanged();
	});
	$("input[type='number']").change(function() {
		processCurrentFilter();
	});
	if ($("#inpIP").val() == "")
		$("#inpIP").val("\\d*\\.\\d*\.\\d*\\.\\d*");
	if ($("#inpMLines").val() == 0)
		$("#inpMLines").val(maxReturnedLines);
	getTestSetup();
}

var filters = Array();
function Filter(name, pattern, logFile) { this.name = name; this.pattern = pattern; this.logFile = logFile; }

function getTestSetup() {
	$.get("getTestSetup", function(response) {
		var v = $.xml2json(response);
		var h = "";
		if (v === undefined)
			return;
		if (v.logFiles === undefined)
			return;
		var logs = v.logFiles;
		logs = logs.logFile;
		//v = v.logFile;
		if (isArray(logs)) {
			for (var i=0; i<logs.length; i++) {
				h += "<option value=\"" + i + "\">" + logs[i] + "</option>\n";
			}
		} else {
			h += "<option>" + logs + "</option>\n";
		}
		$("#logFiles").html(h);
		if (v.regexps === undefined)
			return;
		if (v.regexps.regexp === undefined)
			return;
		var regexps = v.regexps.regexp;
		h = "";
		if (isArray(regexps)) {
			for (var i=0; i<regexps.length; i++) {
				var r = regexps[i];
				var f = new Filter(r.name, r.pattern, r.logFile);
				filters[i] = f;
				h += '<option value="' + i + '">' + f.name + "</option>\n";
			}
		} else {
			alert("single regexp");
		}
		$("#filters").html(h);
		processCurrentFilter();
	})
	.fail(function() {
		$("#output").html('<div class="errorClass">getTestConfig command failed</div>');
	});
}

/**
 * url params to testFilter:
 * %d index to log file
 * %d number of results to return
 * %s regex to match
 * %s regex to fetch ip
 */
function processCurrentFilter() {
	var f = $("#logFiles option:selected").val();
	var r = $("#inpRegexp").val();
	var d = $("#output");
	maxReturnedLines = $("#inpMLines").val();
	if (maxReturnedLines < 1) {
		maxReturnedLines = 4;
		$("#inpMLines").val(4);
	}
	var args=f + "|" + maxReturnedLines + "|" + encodeURIComponent(r) + "|" + encodeURIComponent($("#inpIP").val());
	$.get("testFilter?" + args, function(response) {
		var v = $.xml2json(response);
		var h = "";
		if (v === undefined || v.length == 0 || v.Line === undefined) {
			d.html('N/A');
			return;
		}
		v = v.Line;
		if (!isArray(v)) {
			var vv = Array();
			vv[0] = v;
			v = vv;
		}
		for (var i=0; i<v.length; i++) {
			var x = v[i].replace(/\+/g, " ");
			h += '<div class=mline>' + decodeURIComponent(x) + "</div>\n";
		}
		d.html(h);
	})
	.fail(function() {
		d.html('<div class="errorClass">testfilter command failed</div>');
	});
}

function doFilterChanged() {
	var f = $("#filters option:selected").val();
	var filter = filters[f];
	$('#logFiles option:contains("' + filter.logFile + '")').prop("selected", true);
	$("#inpRegexp").val(filter.pattern);
	processCurrentFilter();
}

/** Is this object an array?
 * @param o The object to test
 * @returns {Boolean}
 */
function isArray(o) {
	  return Object.prototype.toString.call(o) === '[object Array]'; 
}
